from entity import Entity
from ai import BaseAI, AggressiveWhenSeen
from stats import Stats
from inventory import Inventory
from useable import PotionOfHealing

#player and utils
player = Entity(
	char = "@",
	color = (255, 255, 255),
	name = "Player",
	walkable = False,
	ai_class = BaseAI, #TODO: remove this or dummy it out
	stats = Stats(hp = 10, attack = 2, defense = 1),
    inventory=Inventory(),
)

#monsters - gobbos
gobbo = Entity(
	char = "g",
	color = (30, 168, 41),
	name = "Gobbo",
	walkable = False,
	ai_class  = AggressiveWhenSeen,
	stats = Stats(hp = 5, attack = 1, defense = 0),
)

gobbo_red = Entity(
	char = "g",
	color = (168, 41, 30),
	name = "Red Gobbo",
	walkable = False,
	ai_class  = AggressiveWhenSeen,
	stats = Stats(hp = 1, attack = 2, defense = 0), #this guy can't catch a break
)

#items - conumables
potion_of_healing = Entity(
	char = "!",
	color = (0, 0, 255),
	name = "Potion of Healing",
	walkable = True,
    useable=PotionOfHealing(current_stack=1, maximum_stack=255, consumable=True),
)

